diff -ur mod_fastcgi-2.2.12.orig/mod_fastcgi.c mod_fastcgi-2.2.12/mod_fastcgi.c
--- mod_fastcgi-2.2.12.orig/mod_fastcgi.c	Wed Nov 28 12:31:02 2001
+++ mod_fastcgi-2.2.12/mod_fastcgi.c	Tue Jun  4 12:21:47 2002
@@ -1288,7 +1288,7 @@
     return FCGI_OK;
 }
 
-static int server_error(fcgi_request *fr)
+static int server_error_with_error_code(fcgi_request *fr, int error_code)
 {
 #if defined(SIGPIPE) && MODULE_MAGIC_NUMBER < 19990320
     /* Make sure we leave with Apache's sigpipe_handler in place */
@@ -1297,7 +1297,12 @@
 #endif
     close_connection_to_fs(fr);
     ap_kill_timeout(fr->r);
-    return SERVER_ERROR;
+    return error_code;
+}
+
+static int server_error(fcgi_request *fr)
+{
+    return server_error_with_error_code(fr, SERVER_ERROR);
 }
 
 static void cleanup(void *data)
@@ -1365,7 +1370,7 @@
     /* Connect to the FastCGI Application */
     ap_hard_timeout("connect() to FastCGI server", r);
     if (open_connection_to_fs(fr) != FCGI_OK) {
-        return server_error(fr);
+        return server_error_with_error_code(fr, HTTP_SERVICE_UNAVAILABLE);
     }
 
     numFDs = fr->fd + 1;
@@ -1477,7 +1482,7 @@
                         ap_log_rerror(FCGI_LOG_ERR_NOERRNO, r,
                             "FastCGI: comm with (dynamic) server \"%s\" aborted: (first read) idle timeout (%d sec)",
                             fr->fs_path, idle_timeout);
-                        return server_error(fr);
+                        return server_error_with_error_code(fr, HTTP_GATEWAY_TIME_OUT);
                     }
                 }
 
